import { TRPCClientErrorLike } from '@trpc/client';
export * from '@trpc/client';
import { C as CreateTRPCQueryOptions, a as CreateTRPCMutationOptions } from './createTRPCSvelte-461d3d3d.js';
export { d as CreateTRPCSvelte, b as createTRPCSvelte, c as createTRPCSvelteClient } from './createTRPCSvelte-461d3d3d.js';
import { AnyRouter, AnyMutationProcedure, AnyQueryProcedure, AnyProcedure, inferProcedureInput } from '@trpc/server';
import { inferTransformedProcedureOutput } from '@trpc/server/shared';
import '@tanstack/svelte-query';
import 'svelte/store';

/**
 * @internal
 */
type InferQueryOptions<TProcedure extends AnyProcedure, TPath extends string> = Omit<CreateTRPCQueryOptions<TPath, inferProcedureInput<TProcedure>, inferTransformedProcedureOutput<TProcedure>, inferTransformedProcedureOutput<TProcedure>, TRPCClientErrorLike<TProcedure>>, 'select'>;
/**
 * @internal
 */
type InferMutationOptions<TProcedure extends AnyProcedure> = CreateTRPCMutationOptions<inferProcedureInput<TProcedure>, TRPCClientErrorLike<TProcedure>, inferTransformedProcedureOutput<TProcedure>>;
type inferSvelteQueryProcedureOptions<TRouter extends AnyRouter, TPath extends string = ''> = {
    [TKey in keyof TRouter['_def']['record']]: TRouter['_def']['record'][TKey] extends infer TRouterOrProcedure ? TRouterOrProcedure extends AnyRouter ? inferSvelteQueryProcedureOptions<TRouterOrProcedure, `${TPath}${TKey & string}.`> : TRouterOrProcedure extends AnyMutationProcedure ? InferMutationOptions<TRouterOrProcedure> : TRouterOrProcedure extends AnyQueryProcedure ? InferQueryOptions<TRouterOrProcedure, `${TPath}${TKey & string}`> : never : never;
};

export { inferSvelteQueryProcedureOptions };
